//Colin Weed
//10/20/20
//Ballons Code
//I'm using some of Alyssa's code and I've changed/edited it


int numcircles = 0;              
Circles[] circles=new Circles[1000];//This is the number of circles being put into the sketch

void setup() {
  size(600, 600);
  background(random(0), random(250), random(250));; //everytime the sketch starts up there will be a different colored background 
}

void draw() {
  circles[numcircles] = new Circles(); //creates new cirlces
  circles[numcircles].check();        //calling check
  circles[numcircles].paint();        //calling paint 
}

class Circles {
  float x, y, diameter;        //x/y positions and diameter for "Cirlces" 
  color c;                     
  boolean overlapping = true; //This is the boolean variable for overlapping



  Circles() {
    diameter= random(4, 200);                      
    x= random(0+diameter/1, width-diameter/1);       
    y= random(0+diameter/1, height-diameter/1);      //this make it so that the circles stay within the sketch
    c= color(250);
  }

  void check() { // check function for no overlapping
    for (int i= 0; i<numcircles; i++) {           //creates loop for each item 
      Circles other = circles[i];                 //new circles
      float d=dist(x, y, other.x, other.y);       //checks distance of new circles/old cirlces at the x,y point
      println(d);                                 // print statement 
      if (d < diameter/2 + other.diameter/2) {    //when d is less than the diameter+other.diameter than overlapping is false
        overlapping = false;            
        break;                                    //inorder to break the loop overlapping has to equal false
      } 
    }
  }

  void paint() { //paint function to actually create new circles

    if (overlapping== true) {             //defines what going to happen when overlapping = true
      strokeWeight(3);        
      fill(c);
      ellipse(x, y, diameter, diameter);   
        numcircles++;                      //adding circles

    }
  }
}
